// Basic node stored in leftist heaps
// Note that this class is not accessible outside
// of package DataStructures

class LeftHeapNode {
   // Constructors
   LeftHeapNode(Comparable theElement) {
      this(theElement, null, null);
   }

   LeftHeapNode(Comparable theElement, LeftHeapNode lt, LeftHeapNode rt) {
      element = theElement;
      left = lt;
      right = rt;
      npl = 0;
   }

   // Friendly data; accessible by other package routines
   Comparable element;      // The data in the node
   LeftHeapNode left;         // Left child
   LeftHeapNode right;        // Right child
   int npl;          // null path length

   @Override
   public String toString() {
      String str = "";
      if(left != null) str += left.toString() + " ";
      str += element;
      if(right != null) str += " " + right.toString();
      return str;
   }

   public String nplStr() {
      String str = "";
      str += element;
      LeftHeapNode node = getNPLNode();
      if(node != null) {
         str += " " + node.nplStr();
      }
      return str;
   }

   public LeftHeapNode getNPLNode() {
      if(left == null || right == null)
         return null;
      else {
         if(left.npl <= right.npl)
            return left;
         else
            return right;
      }
   }
}
